package Code.FIELD
{
   import Box2D.Collision.Shapes.*;
   import Box2D.Common.Math.b2Vec2;
   import Code.FIELD.body.*;
   import Code.FIELD.effects._xj355;
   import Code.FIELD.helpers.*;
   import Code.FIELD.interfaces._ny544;
   import Code.LIB.*;
   import Code.LIB.COMPONENTS.*;
   import Code.LIB.SOUND._bu111;
   import Code.OPTIONS._gs337;
   import Code._fi197;
   import flash.events.*;
   import mochi.as3.MochiDigits;
   
   public class _dq803 extends _gt710
   {
      public static const FPS:int = 25;
      
      public static const SPEED_BEGINNER:int = int(5.6 * FPS);
      
      public static const SPEED_LOW:int = int(5.3 * FPS);
      
      public static const SPEED_MEDIUM:int = int(4.5 * FPS);
      
      public static const SPEED_HIGH:int = int(4 * FPS);
      
      public static const SPEED_EXTRA:int = int(3.5 * FPS);
      
      public static const SPEED_ARRRR:int = int(2.3 * FPS);
      
      public static const PHYS_SCALE:Number = 30;
      
      public static const stShow:int = 0;
      
      public static const stNormal:int = 1;
      
      public static const stPause:int = 2;
      
      public static const stWin:int = 3;
      
      public static const stGameOver:int = 4;
      
      public var iDeadLine:Number;
      
      private var iPause:Boolean = false;
      
      private var iExploded:int;
      
      private var iSelecter:_dm218;
      
      private var iPb:_is281;
      
      private var iGenerator:_nq133;
      
      private var iCheckTimer:int;
      
      private var iState:int;
      
      public var iWorld:_pn539;
      
      public var iBShake:_ct751;
      
      public var iLevel:Object;
      
      public var iScore:MochiDigits;
      
      public var iEmitPoints:Array;
      
      public function _dq803(param1:Object, param2:TShapeType, param3:int)
      {
         var _loc4_:Array = null;
         var _loc5_:Array = null;
         var _loc6_:int = 0;
         var _loc7_:b2Vec2 = null;
         iPause = false;
         _loc4_ = [[_fi197._tr788,"shakes",_gs337.cAqua,90,35,15,_gs337.cWhite,null,430,420,"iBShake",true]];
         super(_loc4_);
         iLevel = param1;
         iEmitPoints = new Array();
         _loc5_ = (iLevel.map.emitPoints as Array).slice(0,iLevel.map.emitPoints.length);
         _loc6_ = 0;
         while(_loc6_ < _loc5_.length)
         {
            _loc7_ = _loc5_[_loc6_];
            iEmitPoints.push(new b2Vec2(_loc7_.x,_loc7_.y - 120 - _loc6_ * 120));
            _loc6_++;
         }
         iDeadLine = iLevel.map.deadLine[0].y;
         iScore = new MochiDigits();
         iWorld = new _pn539(this,param2);
         iGenerator = new _nq133(this,iLevel.speed,iLevel.bonusDelay,param3);
         addChild(iWorld.iDisplay);
         addChild(iWorld.iArtifactsC);
         this.init();
         iSelecter = new _dm218(this);
         alpha = 1;
         iBShake._xs48 = "shakes: " + iWorld.iShakes;
         _xe768(10,10);
         iGenerator._to710();
         State = stNormal;
      }
      
      public function get pause() : Boolean
      {
         return iPause == true;
      }
      
      public function set pause(param1:Boolean) : void
      {
         iPause = param1;
         iSelecter.iOff = param1;
      }
      
      private function init() : void
      {
         var _loc1_:Array = null;
         _loc1_ = _wo607._ao618(200);
         iPb = new _is281(_loc1_[1],_loc1_[0],_loc1_[2]);
         iPb._xe768(570,290);
         addChild(iPb);
         iExploded = 0;
      }
      
      override public function _fl204(param1:MouseEvent) : void
      {
         if(iPause)
         {
            return;
         }
         super._fl204(param1);
         switch(iState)
         {
            case stNormal:
               _mu339(param1);
         }
      }
      
      private function _mu339(param1:MouseEvent) : void
      {
         var _loc2_:_kc461 = null;
         var _loc3_:Array = null;
         var _loc4_:Number = NaN;
         var _loc5_:_xj355 = null;
         if(param1.target == iBShake._en365)
         {
            if(iWorld.iShakes > 0)
            {
               iWorld._np605(2);
               --iWorld.iShakes;
               iBShake._xs48 = "shakes: " + iWorld.iShakes;
               iCheckTimer = 0;
               return;
            }
         }
         if(param1.target is _ny544)
         {
            iWorld._gy612(_ny544(param1.target));
         }
         else if(param1.target is _wx790)
         {
            _loc2_ = _wx790(param1.target).iShape;
            if(_loc2_ is _ny544)
            {
               iWorld._gy612(_ny544(_loc2_));
               return;
            }
            if(_loc2_)
            {
               _loc3_ = iWorld.iContactSolver._hd293(_loc2_);
               if(_loc3_.length < 3)
               {
                  _loc3_ = iSelecter.brunch;
               }
               if(_loc3_.length >= 3)
               {
                  iWorld._fq230(_loc3_);
                  _lf388 += _loc3_.length;
                  iScore._au109(_loc3_.length * 5);
                  if(_loc3_.length >= 5)
                  {
                     iScore._au109(15);
                     _loc5_ = new _xj355(23,_gs337.cWhite,_my111.SmallText);
                     _loc5_.Text = "+15 " + _gs337.iLanguage.strBonusPoints;
                     _loc5_._xe768(mouseX / _rs402._oy577,mouseY / _rs402._oy577);
                     addChild(_loc5_);
                  }
                  _loc4_ = Math.random() * 10;
                  if(_loc4_ <= 5)
                  {
                     _bu111._wu209("pop1");
                  }
                  else
                  {
                     _bu111._wu209("pop2");
                  }
               }
            }
         }
      }
      
      public function get State() : int
      {
         return iState;
      }
      
      public function set _lf388(param1:int) : void
      {
         this.iExploded = param1;
         this.iPb._io94 = iExploded / iLevel.needToExplode * 100;
      }
      
      public function get score() : Number
      {
         return iScore.value;
      }
      
      override public function _dx150() : void
      {
         super._dx150();
         iSelecter._dx150();
         iWorld._dx150();
         trace("free");
      }
      
      override public function onEnterFrame(param1:Event) : void
      {
         var _loc2_:Number = NaN;
         if(iPause)
         {
            return;
         }
         super.onEnterFrame(param1);
         switch(iState)
         {
            case stNormal:
               iWorld.onEnterFrame();
               iGenerator.onEnterFrame();
               if(++iCheckTimer > 130)
               {
                  iCheckTimer = 0;
                  _loc2_ = iWorld._fp416();
                  if(_loc2_ <= iDeadLine)
                  {
                     State = stGameOver;
                  }
               }
               if(iExploded >= iLevel.needToExplode)
               {
                  State = stWin;
               }
               break;
            case stWin:
               iWorld.onEnterFrame();
         }
      }
      
      public function get _lf388() : int
      {
         return iExploded;
      }
      
      public function set State(param1:int) : void
      {
         iState = param1;
         switch(iState)
         {
            case stNormal:
               iGenerator.start();
               iCheckTimer = 0;
               break;
            case stGameOver:
               iWorld.stop = true;
               iSelecter.iOff = true;
               iGenerator.stop();
               break;
            case stWin:
               iSelecter.iOff = true;
               iGenerator.stop();
         }
      }
   }
}

