package Code.FIELD.body
{
   import Box2D.Collision.Shapes._hx306;
   import Box2D.Collision.Shapes._sw544;
   import Box2D.Collision.Shapes._uy491;
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Dynamics._qh446;
   import Box2D.Dynamics._th791;
   import Code.FIELD._dq803;
   import Code.FIELD._pn539;
   import Code.LIB._nc381;
   import flash.geom.Point;
   
   public class _cl647
   {
      private var iFallingTimer:int;
      
      protected var iDisplay:_oa84;
      
      public var iBodyDef:_qh446;
      
      public var iB2Body:_th791;
      
      public var iWorld:_pn539;
      
      public var iShapesList:Array;
      
      public var iShapes:Array;
      
      public var isFalling:Boolean = true;
      
      public function _cl647(param1:_th791, param2:_pn539, param3:int = 5, param4:int = 5)
      {
         isFalling = true;
         super();
         iB2Body = param1;
         iShapes = _nc381.create(param3,param4);
         iShapesList = new Array();
         iWorld = param2;
         iFallingTimer = 0;
      }
      
      public function _dx150() : void
      {
         while(iShapesList.length > 0)
         {
            _mi548(iShapesList[0]);
         }
      }
      
      public function get display() : _oa84
      {
         return iDisplay;
      }
      
      public function onEnterFrame() : void
      {
         var _loc1_:b2Vec2 = null;
         var _loc2_:Point = null;
         var _loc3_:Boolean = false;
         var _loc4_:Number = NaN;
         _loc1_ = iB2Body._jq282();
         _loc2_ = new Point(_loc1_.x * _dq803.PHYS_SCALE,_loc1_.y * _dq803.PHYS_SCALE);
         _loc3_ = false;
         if(Math.abs(_loc2_.x - iDisplay._vq458) > 0.1)
         {
            iDisplay._vq458 = _loc2_.x;
            _loc3_ = true;
         }
         if(Math.abs(_loc2_.y - iDisplay._vg471) > 0.1)
         {
            iDisplay._vg471 = _loc2_.y;
            _loc3_ = true;
         }
         _loc4_ = int(iB2Body._gm184() * 180 / Math.PI);
         if(Math.abs(_loc4_ - iDisplay.rotation) > 0.1)
         {
            iDisplay.rotation = _loc4_;
            _loc3_ = true;
         }
         if(!_loc3_)
         {
            iDisplay.cacheAsBitmap = true;
         }
         if(isFalling && ++iFallingTimer > 60)
         {
            isFalling = false;
         }
      }
      
      public function get _ss177() : _th791
      {
         return iB2Body;
      }
      
      public function _ky348() : _oa84
      {
         iDisplay = new _oa84(this);
         onEnterFrame();
         return iDisplay;
      }
      
      public function _mi548(param1:_kc461) : void
      {
         var _loc2_:int = 0;
         var _loc3_:Boolean = false;
         var _loc4_:int = 0;
         var _loc5_:int = 0;
         _loc3_ = false;
         _loc4_ = 0;
         while(_loc4_ < iShapes.length)
         {
            _loc2_ = int(iShapes[_loc4_].indexOf(param1));
            if(_loc2_ >= 0)
            {
               iShapes[_loc4_][_loc2_] = 0;
               _loc3_ = true;
               break;
            }
            _loc4_++;
         }
         iShapesList.splice(iShapesList.indexOf(param1),1);
         _loc5_ = int(iWorld.iShapes.indexOf(param1));
         iWorld.iShapes.splice(_loc5_,1);
         iB2Body._jv794(param1._pr238);
         iDisplay._wy690();
         iB2Body._sb691();
      }
      
      public function _kh570(param1:_sw544, param2:int, param3:int, param4:int) : _kc461
      {
         var _loc5_:_hx306 = null;
         var _loc6_:_kc461 = null;
         _loc5_ = iB2Body._vv93(param1);
         _loc6_ = new _kc461(this,_loc5_,param4,param1 is _uy491 ? _kc461.CIRCLE : _kc461.POLYGON);
         _loc6_.iShapeDef = param1;
         iShapes[param2][param3] = _loc6_;
         _loc6_.iI = param2;
         _loc6_.iJ = param3;
         iShapesList.push(_loc6_);
         iWorld.iShapes.push(_loc6_);
         return _loc6_;
      }
      
      public function _aw415(param1:_kc461, param2:int, param3:int) : void
      {
         var _loc4_:_kc461 = null;
         _loc4_ = param1;
         iShapes[param2][param3] = _loc4_;
         _loc4_.iI = param2;
         _loc4_.iJ = param3;
         iShapesList.push(_loc4_);
         iWorld.iShapes.push(_loc4_);
      }
      
      public function get _if196() : Array
      {
         return iShapes;
      }
      
      public function _bb644(param1:b2Vec2) : _kc461
      {
         var _loc2_:_hx306 = null;
         _loc2_ = iB2Body._tq424();
         while(_loc2_)
         {
            if(_loc2_._oa256(iB2Body._lq766(),param1))
            {
               return _loc2_.m_userData.tshape;
            }
            _loc2_ = _loc2_._ix313();
         }
         return null;
      }
   }
}

