package Code.LIB.animators
{
   import Code.LIB._be548;
   
   public class _aj302 extends _do643
   {
      public static const ROTATE_AND_HIDE:int = 0;
      
      public static const ROTATE_AND_SHOW:int = 1;
      
      private static const stNone:int = 0;
      
      private static const stRotateShow:int = 1;
      
      private static const stRotateHide:int = 2;
      
      private var mode:int;
      
      private var state:int;
      
      public function _aj302(param1:_be548, param2:int)
      {
         super(param1);
         this.mode = param2;
         State = stNone;
      }
      
      override public function _kx70() : Boolean
      {
         return state == stNone;
      }
      
      override public function animate(param1:Object = null) : void
      {
         super.animate();
         State = mode == ROTATE_AND_HIDE ? stRotateHide : stRotateShow;
      }
      
      override public function onEnterFrame() : void
      {
         switch(state)
         {
            case stRotateShow:
               target.rotation += 20;
               if(target.scaleX < 1)
               {
                  target.scaleX = target.scaleY = target.scaleY + 0.06;
               }
               else if(target.rotation == 0)
               {
                  target.scaleX = target.scaleY = 1;
                  State = stNone;
               }
               break;
            case stRotateHide:
               target.rotation -= 20;
               if(target.scaleX > 0)
               {
                  target.scaleX = target.scaleY = target.scaleY - 0.09;
               }
               else if(target.rotation < 21)
               {
                  target.rotation = 0;
                  target.scaleX = target.scaleY = 1;
                  State = stNone;
               }
         }
      }
      
      public function set State(param1:int) : void
      {
         this.state = param1;
         switch(state)
         {
            case stRotateShow:
               target.scaleX = target.scaleY = 0;
               break;
            case stRotateHide:
               target.scaleX = target.scaleY = 1;
         }
      }
   }
}

